package com.xkrs.straw.model.helper;

import com.xkrs.straw.model.entity.SysUserEntity;
import com.xkrs.straw.model.vo.AllFirePointVo;
import com.xkrs.utils.SMSUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class SMSHelper {

    public static Logger log = LoggerFactory.getLogger(SMSHelper.class);

    public SMSHelper() {
    }

    public void dispatchSMSMessage(List<SysUserEntity> smsReceiverList, String[] templateParamArray, AllFirePointVo[] detailParamArray) {
        if (smsReceiverList != null && smsReceiverList.size() > 0) {
            String[] telephoneArray = new String[smsReceiverList.size()];
            for (int i = 0; i < smsReceiverList.size(); i++) {
                telephoneArray[i] = "86" + smsReceiverList.get(i).getUserName();
            }
            xingkeSMSMessage(telephoneArray, templateParamArray, detailParamArray);
        }
    }

    /**
     * 星科瑞升向用户发送短信
     */
    private void xingkeSMSMessage(String[] telephoneArray, String[] templateParamArray, AllFirePointVo[] detailParamArray) {
        int resValue = SMSUtils.sendSmsToUser(telephoneArray, "1425995", templateParamArray);
        String sendResult = resValue == 0 ? "短信通知发送成功！" : "短信通知发送失败！";
        //记录短信通知日志
        StringBuilder stringBuilder = new StringBuilder("发送人：青岛星科瑞升信息科技有限公司\n");
        for (String telephone : telephoneArray) {
            stringBuilder.append("接收人：").append(telephone).append("\n");
        }
        for (String templateParam : templateParamArray) {
            stringBuilder.append("模板参数：").append(templateParam).append("\n");
        }
        for (AllFirePointVo detailParam : detailParamArray) {
            stringBuilder.append("超级详细的参数：").append(detailParam.toString()).append("\n");
        }
        stringBuilder.append(sendResult);
        log.info(stringBuilder.toString());
    }

}
